
using System;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using NppScripts;

// SoldierEPilot 23-01-2015
// For non-commercial usage only
public class Script : NppScript
{
 static public string GetSelectedText()
        {
            int start = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONSTART, 0, 0);
            int end = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONEND, 0, 0);
            var text = new StringBuilder(end - start + 1);
            Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELTEXT, 0, text);
            return text.ToString();
        }

  private static string MultyLine(string listing)
  {
	   Regex rex=new Regex(@";");
	   string s=(rex.Replace(listing,";\n"));
	   return(s);
  }
  
   // Remove empty lines
   private static string NoEmptyLines(string txt)
{   
    Regex rex=new Regex("\r\n\r\n");
    return(rex.Replace(txt,""));
    
 }
  
  
  // *.csv line --> sqf multi-line listing
 private static string RPLS(string tx)
 {
	string nm, code, cmnt;
	
	// Get function name
	int p=tx.IndexOf(",");
	nm=tx.Substring(0, p);
	nm=nm.Replace(@"""", @"");
	nm=nm.Trim();
	nm=nm+ "={\n";
	
	// Get comments  
	int p2=tx.LastIndexOf(@",");
	cmnt=tx.Substring(p2+1, tx.Length-p2-1);
	cmnt=cmnt.Trim();

	// Get function body 
	code=tx.Substring(p+1, p2-p-1);
	code=code.Trim();
	code=code.Substring(1, code.Length-2);
	code=code.Replace(@"""""", @"""");
	
	// Format and merge
	code=MultyLine(code);
	code=code+ "\n};";
	tx=nm+code;
	tx=@"comment{" + cmnt + @"};" + "\n" + tx;
	return (tx);
 }
 
 
 // The same as RPLS, but used on not commented lines
 // 4 example:
 // MCAR_SomeFn, "function body"
  
 private static string RPLS2(string tx)
 {
  string nm, code;
  
  // Get function name
  int p=tx.IndexOf(",");
  nm=tx.Substring(0,p-1);
  nm=nm.Replace(@"""", @"");
  nm=nm.Trim();
  nm=nm+ "={\n";
  
  // Get function body
  code=tx.Substring(p+1,tx.Length-p-1);
  code=code.Trim();
  code=code.Replace(@"""""", @"""");
  code=code.Substring(1,code.Length-2); 
  
  // Format and merge
  code=MultyLine(code);
  code=code+ "\n};";
  tx=nm+code;
  return (tx);
 }

 // Put constructed sqf listing to clipboard
 [STAThread]
    public override void Run()
    {
	    string txt, s, curr;
		string[] csv_lines;
	    txt=GetSelectedText();
		if ((txt.Length)>0)
		{
		
		    csv_lines=Regex.Split(txt, "\n");
			
			if (2>csv_lines.Length)
			
			// One line selected
			{Clipboard.SetText(RPLS(txt), TextDataFormat.Text);}
			else
			{
			 // Many lines selected
			 txt=NoEmptyLines(txt);
			  s="";
			  foreach (string csvline in csv_lines)
			 {
			    curr=csvline.Trim();
			    if (curr.Length>0)
				{
				  if(curr.EndsWith(@""""))
				  {
				    s+=("\n\n\n" + RPLS2(curr));
				  }
				  else
				  {
				    s+=("\n\n\n" + RPLS(curr));
				  };
					
				};
			 };
			 Clipboard.SetText(s, TextDataFormat.Text); 
			
		    }
		    MessageBox.Show("Ready to paste!");
        }
	}	
}

