using System;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using NppScripts;

public class Script : NppScript
{
	//      7z
	static string PATH_7Z = @"C:\Program Files\7-Zip\7z.exe";
	
	//     
    //        
	static string RunProc (string file, string args)
	{
		Process p = new Process();
		p.StartInfo.FileName=file;
		p.StartInfo.Arguments=args;
		p.StartInfo.UseShellExecute = false;
		p.StartInfo.CreateNoWindow = true;
		p.StartInfo.RedirectStandardOutput = true;
		p.Start();
		string output = p.StandardOutput.ReadToEnd();
		p.WaitForExit();
		return (output);
	}
	
	//      
	public static void Z7_File(string path)
	{
		string name = Path.GetFileNameWithoutExtension(path);
		string Q = @"""";
		string desk =  System.Environment.GetFolderPath(Environment.SpecialFolder.Desktop); 
		string zip_path = Q + desk + @"\" + name  + ".7z" + Q;
		
		string cmd = "a " +  zip_path +
	    " " + Q + path + Q + " -mx9";
		
	    string output = RunProc(PATH_7Z, cmd);
		
		if (output.IndexOf("Everything is Ok")>-1)
		{
			MessageBox.Show("OK");
		} else
		{
			MessageBox.Show(output);
		}		
	}
	
	//        
	public static void Z7_Folder(string curDir)
	{
	    string name = Path.GetFileName(curDir);
		string Q = @"""";
		string desk =  System.Environment.GetFolderPath(Environment.SpecialFolder.Desktop); 
		string zip_path = Q + desk + @"\" + name  + ".7z" + Q;
		
		string cmd = "a " +  zip_path +
	    " " + Q + curDir + @"\" + Q + " -mx7";
		
	    string output = RunProc(PATH_7Z, cmd);
		
		if (output.IndexOf("Everything is Ok")>-1)
		{
			MessageBox.Show("OK");
		} else
		{
			MessageBox.Show(output);
		}		
	}
	
    public override void Run()
    {
		
		//   
		if (System.IO.File.Exists(PATH_7Z))
		{
			string curDir, path;
			Win32.SendMessage(Npp.NppHandle, NppMsg.NPPM_GETCURRENTDIRECTORY, 0, out curDir);
			Win32.SendMessage(Npp.NppHandle, NppMsg.NPPM_GETFULLCURRENTPATH, 0, out path);
					
			int res = (int)MessageBox.Show
			(
				"    ?",
				" ", 
				MessageBoxButtons.YesNo,
				MessageBoxIcon.Question, 
				MessageBoxDefaultButton.Button2
			);
			if (res==6)
			{
				Z7_Folder(curDir);
			}
			else
			{
				Z7_File(path);
			}	
		}
		else
		{
			MessageBox.Show(
			" 7z.exe  !      PATH_7Z"
			);
		}	
				
	}
}