
using System;
using System.Windows.Forms;
using System.Text;
using System.Text.RegularExpressions;
using NppScripts;

public partial class MyForm:Form
{
	public TreeView TV1;
	
	public MyForm()
	{
		this.Width=500;
		this.Height=800;
		this.Text="Dependences";
		TV1 = new TreeView();
		TV1.Width=495;
		TV1.Height=795;
		this.Controls.Add(TV1);
		this.Load += makeTV;
	}
	
	
	//     NPP  
	public static string GetSelectedText()
    {
		int start = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONSTART, 0, 0);
		int end = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONEND, 0, 0);
		var text = new StringBuilder(end - start + 1);
		Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELTEXT, 0, text);
		return text.ToString();
    }
	
	
	//    
	private static string[] TextLines(string tx)
	{
		Regex rex = new Regex (@"\n");
		return rex.Split(tx);
	}
	
	
    // ,   - csv 	
	public static bool isFunction (string line)
	{
		var rex = new Regex (@"^[a-zA-Z][a-zA-Z0-9_]+?\,");
		return (rex.IsMatch(line));
	}
	
	
	//     
	//    
	public void AddDepended(TreeNode node)
	{
		if (node!=null)
		{
			if (TV1.Nodes.ContainsKey(node.Name))
			{
				foreach (TreeNode node2 in TV1.Nodes[node.Name].Nodes)
				{
					node.Nodes.Add(node2.Name);
					AddDepended(node.Nodes[node2.Name]);
				}	
			}
		}	
	}


	//  2-   -   
	//     stringtable.csv
	public void makeTV(object sender, System.EventArgs e)
    {
		TV1.BeginUpdate();
		string txt = GetSelectedText();
		
		foreach (string line in TextLines(txt))
		{
			 if (line.Length>10)
			 {
				if (isFunction(line))
				{
					var rex = new Regex (@"(?<=call localize\{)[a-zA-Z0-9_]+?\}");
					string nv = line.Substring(0, line.IndexOf(','));
					TV1.Nodes.Add(nv, nv);
					var MC = rex.Matches (line);
					foreach (Match M in MC)
					{
						string v = M.Value;
						v = v.Replace(@"{", "");
						v = v.Replace(@"}", "");
					 	if (!(TV1.Nodes[nv].Nodes.ContainsKey(v)))
						{
							TV1.Nodes[nv].Nodes.Add(v, v);
						}	 
						
					}
				}
			 }	 
		}
		
		 foreach (TreeNode TN1 in TV1.Nodes)
		 {
			 foreach (TreeNode TN2 in TN1.Nodes)
			 {
				AddDepended(TN2); 
			 }
		 } 
		 
		 TV1.EndUpdate();
    }
}


public class Script : NppScript
{
    public override void Run()
    {
	   Form MainForm = new MyForm();
       Application.Run(MainForm);
    } 
}