
//npp_toolbar_image Shell32.dll|53

using System;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using System.Xml.Serialization;
using NppScripts;


//     
public class PBO_Settings
{
	public string PBTL;
	public string Destination;

	public void Write(string Path2XML)
	{
		Stream writer = new FileStream(Path2XML, FileMode.Create);
		XmlSerializer sr = new XmlSerializer(this.GetType());
		sr.Serialize(writer, this);
		writer.Close();
	}
	
	public PBO_Settings()
	{
		this.PBTL = "";
		this.Destination = "";
	}
	
	public PBO_Settings(string Path2XML)
	{
		if (File.Exists(Path2XML))
		{
			Stream stream = new FileStream(Path2XML, FileMode.Open);
			XmlSerializer serializer = new XmlSerializer(this.GetType());
			PBO_Settings s = (PBO_Settings)serializer.Deserialize(stream);
			stream.Close();
			this.PBTL = s.PBTL;
			this.Destination = s.Destination;
		}
		else 
		{
			this.PBTL = "";
			this.Destination = "";
		}		
	}
}

public class Script : NppScript
{

	//     
    //        
	static string RunProc (string file, string args)
	{
		Process p = new Process();
		p.StartInfo.FileName=file;
		p.StartInfo.Arguments=args;
		p.StartInfo.UseShellExecute = false;
		p.StartInfo.CreateNoWindow = true;
		p.StartInfo.RedirectStandardOutput = true;
		p.Start();
		string output = p.StandardOutput.ReadToEnd();
		p.WaitForExit();
		return (output);
	}
	
	
	//     
	public static void PBO_Dir(string Dir, PBO_Settings ps)
	{
	    string name = Path.GetFileName(Dir);
		string folder = Dir;
		
		string Q = @"""";		
		string cmd = "-p " + Q + folder + Q;
	    string output = RunProc(ps.PBTL, cmd);
		MessageBox.Show(output);
		
		string p1 = folder + ".pbo";
		string p2 = ps.Destination + @"\" + name + ".pbo";
		MoveFileAnyway(p1, p2);	
	}
	
	
	//  ;      - 
	static void MoveFileAnyway(string p1, string p2)
	{
		if (File.Exists(p2))
		{
			File.Delete(p2);
		}
		if (File.Exists(p1))
		{
			File.Move(p1, p2);
		}	
	}
	
	
	//     PBO 
	public static string GetDestinationFolder()
	{
		FolderBrowserDialog fbd = new FolderBrowserDialog(); 
		fbd.RootFolder = Environment.SpecialFolder.MyComputer; 
		fbd.Description = "     PBO"; 
		if (fbd.ShowDialog() == DialogResult.OK) 
		{
			return fbd.SelectedPath;
		}
		else 
		{
			return "";
		}	
	}
	
	
	//    pbtl.exe
	public static string GetPBTL_Path()
	{
		 OpenFileDialog OFD=new OpenFileDialog();
		 OFD.Filter="pbtl executable|pbtl.exe";
		 OFD.Title="   pbtl.exe";
		 OFD.InitialDirectory=Environment.SpecialFolder.MyComputer.ToString();
		 OFD.ShowDialog();
		 return OFD.FileName;
	}
	

    public override void Run()
    {
		//    XML- 
		// ...ApplicationData\DASH_NPP.xml
		string Path2XML=Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + @"\DASH_NPP.xml";
		
		//   -      -
		PBO_Settings ps = new PBO_Settings(Path2XML);
		
		string pbtl=ps.PBTL;
		string dest=ps.Destination;
		
		//        -  
		if (!(File.Exists(pbtl)))
		{
			pbtl = GetPBTL_Path();
		}	
		
		if (!(Directory.Exists(dest)))
		{
			dest = GetDestinationFolder();
		}
		
		// -   ?
		bool BadPaths = false;
		
		if (pbtl=="")
		{
		   MessageBox.Show ("    pbtl.exe");	
		   BadPaths=true;
		} 
		else 
		{
			ps.PBTL = pbtl;
		}
		
		if (dest=="")
		{
		   MessageBox.Show ("     PBO");	
		   BadPaths=true;
		}
		else 
		{
			ps.Destination = dest;
		}
		
		//     PBO   
		int res = (int)MessageBox.Show
		(
			" PBO   " + Environment.NewLine + dest + @"?",
			" ", 
			MessageBoxButtons.YesNo,
			MessageBoxIcon.Question
		);
		
		//  "" ->     
		if (res!=6)
		{
			dest = GetDestinationFolder();
		}
			
		if (dest=="")
		{
		   MessageBox.Show ("     PBO");	
		   BadPaths=true;
		}
		else 
		{
			ps.Destination = dest;
		}
		
		//  
		ps.Write(Path2XML);
		
		// ,    
		if (BadPaths)
		{
			return;
		}	
		
		//      
		string curDir;
		Win32.SendMessage(Npp.NppHandle, NppMsg.NPPM_GETCURRENTDIRECTORY, 0, out curDir);
		PBO_Dir(curDir, ps);	
	}
				
}
