
using System.Text;
using NppScripts;

public class Script : NppScript
{
	//_u=_u+[_x]; ==> _u set[count _u,_x];
	public string SetInsteadOfPlus(string code)
	{
		code=code.Trim();
		if (code.Length<3)
		{return "";}
	
		int i=code.IndexOf('=');
		if (i<0)
		{return "";}	
		string newCode = code.Substring (0, i).Trim();
		newCode = 
			newCode +
			@" set[count " + 
			newCode +
			",";
		i = code.IndexOf ('[');
		int j = code.LastIndexOf(']');	
		
		if ((i<0) || (j<0))
		{return "";}
	
		if ((i+1)>=code.Length)
		{return "";}
	
		string code2 = code.Substring(i+1, j-i);
		newCode = newCode + code2;
		if (j<(code.Length-1))
		{
			newCode = newCode + code.Substring(j+1,code.Length-j-1);
		}	
		return newCode;
	}
	
	 static public string GetSelectedText()
	{
		int start = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONSTART, 0, 0);
		int end = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONEND, 0, 0);
		var text = new StringBuilder(end - start + 1);
		Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELTEXT, 0, text);
		return text.ToString();
	}
		
	 static public void ReplaceSelection(string text)
	{
		Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_REPLACESEL, 0, text);
	}
		
    public override void Run()
    {		
	  string s = SetInsteadOfPlus(GetSelectedText());
	  if (s.Length>0)
	  {
		  ReplaceSelection(s);
	  }	  
    }
}