qtnNorm={
sqrt((_this select 0)^2+(_this select 1)^2+(_this select 2)^2+(_this select 3)^2)
};

qtnNormalize={
private "_len";
_len=_this call qtnNorm; 
[(_this select 0)/_len+(_this select 1)/_len+(_this select 2)/_len+(_this select 3)/_len]
};


qtnConjugate={
[_this select 0,-(_this select 1),-(_this select 2),-(_this select 3)]
};


qtnPlus={
private[{_a},{_b}];
_a=_this select 0;
_b=_this select 1;
[(_a select 0)+(_b select 0),(_a select 1)+(_b select 1),(_a select 2)+(_b select 2)]
};


qtnMult={
private[{_a},{_b},{_aw},{_ax},{_ay},{_az},{_bw},{_bx},{_by},{_bz}];
_a=_this select 0;
_b=_this select 1;
_aw=_a select 0;
_ax=_a select 1;
_ay=_a select 2;
_az=_a select 3;
_bw=_a select 0;
_bx=_a select 1;
_by=_a select 2;
_bz=_a select 3;
[
	_aw*_bw-_ax*_bx-_ay*_by-_az*_bz,
	_aw*_bx+_ax*_bw+_ay*_bz-_az*_by,
	_aw*_by-_ax*_bz+_ay*_bw+_az*_bx,
	_aw*_bz+_ax*_by-_ay*_bx+_az*_bw
]
};


qtnMultVector={
private[{_a},{_b},{_aw},{_ax},{_ay},{_az},{_bx},{_by},{_bz}];
_a=_this select 0;
_b=_this select 1;
_aw=_a select 0;
_ax=_a select 1;
_ay=_a select 2;
_az=_a select 3;
_bx=_a select 0;
_by=_a select 1;
_bz=_a select 2;
[
    -_ax*_bx-_ay*_by-_az*_bz,
    _aw*_bx+_ay*_bz-_az*_by,
    _aw*_by-_ax*_bz+_az*_bx,
    _aw*_bz+_ax*_by-_ay*_bx
]
};


qtnInverse={
private[{_a0},{_a1},{_a2},{_a3},{_d}];
_a0=_this select 0;
_a1=_this select 1;
_a2=_this select 2;
_a3=_this select 3;
_d=_a0*_a0+_a1*_a1+_a2*_a2+_a3*_a3;
[_a0/_d,-_a1/_d,-_a2/_d,-_a3/_d]
};


qtnDivide={
[_this select 0, (_this select 1) call qtnInverse] call qtnMult
};


qtnFromEuler={
private[{_a1},{_a2},{_a3},{_c1},{_s1},{_c2},{_s2},{_c3},{_s3}];
_a1=_this select 0;
_a2=_this select 1;
_a3=_this select 2;
_c1=cos (_a1*0.5);
_s1=sin (_a1*0.5);
_c2=cos (_a2*0.5);
_s2=sin (_a2*0.5);
_c3=cos (_a3*0.5);
_s3=sin (_a3*0.5);
[
	_c1*_c2*_c3+_s1*_s2*_s3,
	_c1*_c2*_s3-_s1*_s2*_c3,
	_c1*_s2*_c3+_s1*_c2*_s3,
	_s1*_c2*_c3+_c1*_s2*_s3
]
};


qtnFromAxis={
private[{_osa},{_a},{_c},{_s},{_d}];
_osa=_this select 0;
_a=_this select 1;
_c=cos (_a*0.5);
_s=sin (_a*0.5);
_d=sqrt ((_osa select 0)^2 +(_osa select 1)^2 + (_osa select 2)^2);
[
	_c,
	(_osa select 0)*_s/_d,
	(_osa select 1)*_s/_d,
	(_osa select 2)*_s/_d
]
};


qtnRotatePoint={
private[{_q},{_p},{_a},{_x},{_y},{_z},{_px},{_py},{_pz}];
_q=_this select 0;
_p=_this select 1;
_a=_q select 0;
_x=_q select 1;
_y=_q select 2;
_z=_q select 3;
_px=_p select 0;
_py=_p select 1;
_pz=_p select 2;
[
	_a*_a*_px + 2*_y*_a*_pz - 2*_z*_a*_py + _x*_x*_px + 2*_y*_x*_py + 2*_z*_x*_pz - _z*_z*_px - _y*_y*_px,
	2*_x*_y*_px + _y*_y*_py + 2*_z*_y*_pz + 2*_a*_z*_px - _z*_z*_py + _a*_a*_py - 2*_x*_a*_pz - _x*_x*_py,
	2*_x*_z*_px  +  2*_y*_z*_py  +  _z*_z*_pz  -  2*_a*_y*_px  -  _y*_y*_pz  +  2*_a*_x*_py  -  _x*_x*_pz  +  _a*_a*_pz
]
};


qtnRotateVector={
private[{_v},{_q},{_t}];
_v=_this select 0;
_q=_this select 1;
_t=[_q, _v] call qtnMultVector;
[_t, _q] call qtnDivide
};


comment{
    (x=1; y=0; z=1).   180 .
   (maybe point?) (x=0; y=0; z=1).   (x=1; y=0; z=0)
};

vec_rotate={
private[{_v},{_ax},{_c},{_s},{_i},{_j},{_k}];
_v=_this select 0;
_ax=_this select 1;
_c=cos(_this select 2);
_s=sin(_this select 2);
_i=(_this select 0)select 0;
_j=(_this select 0)select 1;
_k=(_this select 0)select 2;
if(_ax==0)then{[_i,_j*_c-_k*_s,_k*_c+_j*_s]}else{if(_ax==1)then{[_i*_c+_k*_s,_j,_k*_c-_i*_s]}else{if(_ax==2)then{[_i*_c-_j*_s,_j*_c+_i*_s,_k]}else{[_i,_j,_k]}}}
};


// q=[[1, 0, 1], 180] call qtnFromAxis;

q = [25,0,0] call qtnFromEuler;
v = [1,2,3];
 
messagebox [str ( [v, q] call qtnRotateVector  ), 0];
//messagebox [str(       [vec, 0, 25] call vec_rotate                 ), 0];


